<?php

class formWidgetContentFieldsOptions extends cmsForm {

    public function init($options=false) {
		
        $fields_list   = array('' => '');

        if (!empty($options['ctype_name'])){

			$content_model = cmsCore::getModel('content');
			$fields = $content_model->getContentFields($options['ctype_name']);
			if ($fields){ $fields_list = array(''=>'') + array_collection_to_list($fields, 'name', 'title'); }

		}
		
        return array(

            array(
                'type' => 'fieldset',
                'title' => LANG_OPTIONS,
                'childs' => array(
				
	
				
                    new fieldList('options:ctype_name', array(
                        'title' => LANG_CONTENT_TYPE,
                        'generator' => function($item) {

                            $model = cmsCore::getModel('content');
                            $tree = $model->getContentTypes();

                            $items = array();

                            if ($tree) {
                                foreach ($tree as $item) {
                                    $items[$item['name']] = $item['title'];
                                }
                            }

                            return $items;

                        },
                    )),
					
					new fieldNumber('options:item_id', array(
                        'title' => 'id записи',  
						'hint' => 'если нужно отобразить поле конретной записи',						
                    )),
						
					
                 

                )
            ),
			
			
			   array(
                'type' => 'fieldset',
                'title' => 'Макет',
                'childs' => array(
				
						new fieldList('options:editor', array(
                'title' => LANG_PARSER_HTML_EDITOR,
                'hint' => 'Новый редактор отобразиться после пересохранения настроек',
                'default' => 'ace',
                'generator' => function($item){
                    $items = [];
                    $editors = cmsCore::getWysiwygs();
                    foreach($editors as $editor){
                        $items[$editor] = ucfirst($editor);
                    }
                    $ps = cmsCore::getModel('wysiwygs')->getPresetsList();
                    if($ps){
                        foreach ($ps as $key => $value) {
                            $items[$key] = $value;
                        }
                    }
                    return $items;
                }
            )),
				
					new fieldHtml('options:html', array(
                        'title' => '<style>#f_options_html textarea{ height:500px; }</style>',  
						'hint' => 'Используйте поля записи, вставляя их названия в фигурных скобках. Например, для типов контента: {title}, {photo} и т.п.',
'options'=>array('editor'=>(!empty($options['editor']) ? $options['editor'] : 'ace'))								
                    )),
				
				)),
				
			   array(
                'type' => 'fieldset',
                'title' => 'Стили',
                'childs' => array(
				
					new fieldHtml('options:styles', array(
                        'title' => '<style>#f_options_styles textarea{ height:500px; }</style>',  
						'hint' => 'можно использоать классы корневого контейнера: .widget_content_field.content_item.[имя типа контента]_item',
'options'=>array('editor'=>'ace')						
                    )),
				
				))

        );

    }

}
