<?php
class widgetContentFields extends cmsWidget {

    public function run(){
		
	$ctype_name = $this->getOption('ctype_name');
	$field_name = $this->getOption('field_name');
	$item_id = $this->getOption('item_id',0);
	
	$string = $this->getOption('html');
	$styles = $this->getOption('styles');
	
	$model = cmsCore::getModel('content');
	
	if(!empty($item_id) && !empty($ctype_name)){
		$ctype = $model->getContentTypeByName($ctype_name);	
	}else{
        $ctype = cmsModel::getCachedResult('current_ctype');	
	}
	if($ctype_name !== $ctype['name']){ return false; }
	
	
	if(!empty($item_id)){
	$item = $model->getContentItem($ctype_name, $item_id);	
	}else{
	$item = cmsModel::getCachedResult('current_ctype_item');	
	}
	if(!$item){ return false; }
	
		if(!empty($item_id)){
			
	 
	    // Получаем поля для данного типа контента
        $fields = $model->getContentFields($ctype['name']);

        // Парсим значения полей
        foreach($fields as $name=>$field){
            $fields[ $name ]['html'] = $field['handler']->setItem($item)->parse( $item[$name] );
            $fields[ $name ]['string_value'] = $field['handler']->getStringValue( $item[$name] );
        }
        
		$fields_fieldsets = cmsForm::mapFieldsToFieldsets($fields, function($field, $user) use ($item) {

            if (!$field['is_in_item'] || $field['is_system'] || $field['name'] == 'title') { return false; }

            if ((empty($item[$field['name']]) || empty($field['html'])) && $item[$field['name']] !== '0') { return false; }

            // проверяем что группа пользователя имеет доступ к чтению этого поля
            if ($field['groups_read'] && !$user->isInGroups($field['groups_read'])) {
                // если группа пользователя не имеет доступ к чтению этого поля,
                // проверяем на доступ к нему для авторов
                if (!empty($item['user_id']) && !empty($field['options']['author_access'])){
                    if (!in_array('is_read', $field['options']['author_access'])){ return false; }
                    if ($item['user_id'] == $user->id){ return true; }
                }
                return false;
            }
            return true;
        });
		
	
		}else{
			
		$fields = cmsModel::getCachedResult('current_ctype_fields');
        $fields_fieldsets = cmsModel::getCachedResult('current_ctype_fields_fieldsets');	
		
		}
		
		
        //$props = cmsModel::getCachedResult('current_ctype_props');
       // $props_fields = cmsModel::getCachedResult('current_ctype_props_fields');
      //  $props_props_fieldsets = cmsModel::getCachedResult('current_ctype_props_props_fieldsets');
	
	

	if(!empty($item['fields_data'][$field_name])){
		$fields[$field_name] = $item['fields_data'][$field_name];
	}
	
	
	$html = '';
	
	$data = array();
	foreach($fields as $key=>$field){
		$data[$key] = $field['html'];
	}
	
	if($string){
		
	$html = $this->string_fields($string, $data);

	}
	
	$this->setTemplate($this->tpl_body);
	
        return array( 'html'=>$html,  'fields'=>$fields, 'fields_fieldsets'=>$fields_fieldsets, 'field_name'=>$field_name, 'ctype_name'=>$ctype_name, 'item'=>$item, 'styles'=>$styles);

    }
	
	
	
	
	
/**
 * Находит внутри строки $string все выражения вида {key}, где key - это ключ
 * массива $data и заменяет на значение соответствующего элемента
 * отличительной особенностью от функции выше является возможность обработки значений функциями
 * например, выражение {age|html_spellcount:год:года:лет} после обработки напишет "21 год, 22 года, 29 лет"
 * при значении age 21, 22 и 29 соответственно
 * выражение {nickname:профиль пользователя %s самый лучший} после обработки станет "профиль пользователя Василий самый лучший"
 * при значении поля nickname в массиве $data "Василий"
 *
 * @param string $string
 * @param array $data
 */
function string_fields($string, $data){		

    $matches_count = preg_match_all('/{([^}]+)}/ui', $string, $matches);


    if ($matches_count){		


        for($i=0; $i<$matches_count; $i++){

            $tag = $matches[0][$i];
            $property = $matches[1][$i];

            $func = false; $func_params = array(); $func_params_property_key = 0;

            // есть ли обработка функцией
            if(strpos($property, '|') !== false){
                $params = explode('|', $property);
                // второй параметр - функция
                $func = $params[1];
                if(function_exists($func) || strpos($func, ':') !== false){

                    // первый параметр остаётся как $property
                    $property = $params[0];
                    // $property ставим как первый параметр функции
                    $func_params = array($property);
                    // смотрим есть ли у функции параметры
                    if(strpos($func, ':') !== false){
                        $par = explode(':', $func);
                        $func = $par[0]; unset($par[0]);
                        if(function_exists($func)){
                            foreach ($par as $k => $p) {
                                // если параметр - массив
                                if(strpos($p, '=') !== false){
                                    $out = array(); parse_str($p, $out);
                                    $par[$k] = $out;
                                }
                            }
                            $func_params = $func_params + $par;
                        } else {
                            $func = false;
                        }
                    }

                } else {

                    // значит рандомные значения из списка
                    $values = explode('|', $property);

                    $string = str_replace($tag, $values[mt_rand(0, (count($values)-1))], $string);

                    continue;

                }
            } else
            // нужно прогнать через sprintf
            if(strpos($property, ':') !== false){
                $params = explode(':', $property);
                $property = $params[0];
                $func = 'sprintf';
                $func_params = array_reverse($params);
                $func_params_property_key = 1;
            }

            if (isset($data[$property]) && !is_array($data[$property]) && !is_object($data[$property])){

                $data_property = $data[$property];

                if($func && function_exists($func)){

                    $func_params[$func_params_property_key] = $data_property;

                    $data_property = call_user_func_array($func, $func_params);

                }

                $string = str_replace($tag, $data_property, $string);

            } else {
                $string = str_replace($tag, '', $string);
            }

        }

    }

    return $string;

}
	
	
	
	
	
	
	
	
	

}
